"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ActionCreatorType;
(function (ActionCreatorType) {
    ActionCreatorType["TYPE_ONLY"] = "TYPE_ONLY";
    ActionCreatorType["PROPS"] = "PROPS";
    ActionCreatorType["PAYLOAD"] = "PAYLOAD";
})(ActionCreatorType = exports.ActionCreatorType || (exports.ActionCreatorType = {}));
var ActionOptType;
(function (ActionOptType) {
    ActionOptType["PROPS"] = "PROPS";
    ActionOptType["PAYLOAD"] = "PAYLOAD";
})(ActionOptType = exports.ActionOptType || (exports.ActionOptType = {}));
function extend(obj, p) {
    var result = obj;
    for (var _i = 0, _a = Object.keys(p); _i < _a.length; _i++) {
        var key = _a[_i];
        result[key] = p[key];
    }
    return result;
}
function action(type, pType) {
    if (pType) {
        switch (pType.__tsdux_opt__) {
            case ActionOptType.PROPS: {
                //tslint:disable-next-line: no-shadowed-variable
                var create_1 = function (props) { return extend(extend({}, props), { type: type }); };
                var properties = {
                    __tsdux_action__: ActionCreatorType.PROPS,
                    type: type,
                    //tslint:disable-next-line: no-shadowed-variable
                    create: function (props) {
                        return create_1(props);
                    },
                    action: undefined,
                };
                //tslint:disable-next-line: no-shadowed-variable
                var creator = extend(create_1, properties);
                return creator;
            }
            case ActionOptType.PAYLOAD: {
                //tslint:disable-next-line: no-shadowed-variable
                var create_2 = function (payload) { return ({ type: type, payload: payload }); };
                var properties = {
                    __tsdux_action__: ActionCreatorType.PAYLOAD,
                    type: type,
                    //tslint:disable-next-line: no-shadowed-variable
                    create: function (payload) {
                        return create_2(payload);
                    },
                    action: undefined,
                };
                var creator = extend(create_2, properties);
                return creator;
            }
            default:
                var x = pType;
                var jsonIndent = 2;
                var rep = JSON.stringify(x, undefined, jsonIndent);
                throw new Error("tsdux error: use `props` or `payload` function when make an action creator\n    " + rep + " is not created by `props` nor `payload`");
        }
    }
    else {
        var create_3 = function () {
            return { type: type };
        };
        var properties = {
            __tsdux_action__: ActionCreatorType.TYPE_ONLY,
            type: type,
            create: function () {
                return create_3();
            },
            action: undefined,
        };
        var creator = extend(create_3, properties);
        return creator;
    }
}
exports.action = action;
function props() {
    return { __tsdux_opt__: ActionOptType.PROPS };
}
exports.props = props;
function payload() {
    return { __tsdux_opt__: ActionOptType.PAYLOAD };
}
exports.payload = payload;
//# sourceMappingURL=action.js.map