export function subreducer(action, handler) {
    return {
        type: action.type,
        handler,
    };
}
export function reducer(initialState, subreducers) {
    const reducerMap = subreducers.reduce((map, { type, handler }) => {
        return Object.assign(Object.assign({}, map), { [type]: handler });
    }, {});
    return function (state = initialState, action) {
        const handler = reducerMap[action.type];
        if (!handler) {
            return state;
        }
        return handler(state, action);
    };
}
//# sourceMappingURL=reducer.js.map