import { Reducer } from 'redux';
import { Action, ActionCreator } from './action';
export interface Subreducer<S, T extends string, P extends object = {}> {
    readonly type: T;
    handler(state: S, action: Action<T, P>): S;
}
export declare function subreducer<S, T extends string, P extends object>(action: ActionCreator<T, P>, handler: Subreducer<S, T, P>['handler']): Subreducer<S, T, P>;
export declare function reducer<S, SR extends Subreducer<S, string, any>>(initialState: S, subreducers: Array<SR>): Reducer<S>;
