"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
function subreducer(action, handler) {
    return {
        type: action.type,
        handler: handler,
    };
}
exports.subreducer = subreducer;
function reducer(initialState, subreducers) {
    var reducerMap = subreducers.reduce(function (map, _a) {
        var _b;
        var type = _a.type, handler = _a.handler;
        return __assign(__assign({}, map), (_b = {}, _b[type] = handler, _b));
    }, {});
    return function (state, action) {
        if (state === void 0) { state = initialState; }
        var handler = reducerMap[action.type];
        if (!handler) {
            return state;
        }
        return handler(state, action);
    };
}
exports.reducer = reducer;
//# sourceMappingURL=reducer.js.map